//Experiment 3-1
/*Nikita Tirjatkin
  Laboratory for in silico life construction
  Januar 2011*/

#include <string>
#include <vector>
#include <iostream>
using namespace std;

class gena
{
  public:
    string RNA;
    gena(string Gene)
    {
        for(int i = 0; i < Gene.size(); i++)
        {
                 if(Gene[i] == 'A') RNA.push_back('U');
            else if(Gene[i] == 'C') RNA.push_back('G');
            else if(Gene[i] == 'G') RNA.push_back('C');
            else if(Gene[i] == 'T') RNA.push_back('A');
            else                    RNA.push_back('-');
        }
    }
};

class genb:public gena
{
  public:
    string Polypeptide;
    genb(string Gene):gena(Gene)
    {
        for(int i = 0; i < RNA.size(); i += 3)
        {
                 if(RNA.substr(i, 3) == "GCA" ||
                    RNA.substr(i, 3) == "GCC" ||
                    RNA.substr(i, 3) == "GCG" ||
                    RNA.substr(i, 3) == "GCU") Polypeptide.push_back('A');
            else if(RNA.substr(i, 3) == "UGC" ||
                    RNA.substr(i, 3) == "UGU") Polypeptide.push_back('C');
            else if(RNA.substr(i, 3) == "GAC" ||
                    RNA.substr(i, 3) == "GAU") Polypeptide.push_back('D');
            else if(RNA.substr(i, 3) == "GAA" ||
                    RNA.substr(i, 3) == "GAG") Polypeptide.push_back('E');
            else if(RNA.substr(i, 3) == "UUC" ||
                    RNA.substr(i, 3) == "UUU") Polypeptide.push_back('F');
            else if(RNA.substr(i, 3) == "GGA" ||
                    RNA.substr(i, 3) == "GGC" ||
                    RNA.substr(i, 3) == "GGG" ||
                    RNA.substr(i, 3) == "GGU") Polypeptide.push_back('G');
            else if(RNA.substr(i, 3) == "CAC" ||
                    RNA.substr(i, 3) == "CAU") Polypeptide.push_back('H');
            else if(RNA.substr(i, 3) == "AUA" ||
                    RNA.substr(i, 3) == "AUC" ||
                    RNA.substr(i, 3) == "AUU") Polypeptide.push_back('I');
            else if(RNA.substr(i, 3) == "AAA" ||
                    RNA.substr(i, 3) == "AAG") Polypeptide.push_back('K');
            else if(RNA.substr(i, 3) == "CUA" ||
                    RNA.substr(i, 3) == "CUC" ||
                    RNA.substr(i, 3) == "CUG" ||
                    RNA.substr(i, 3) == "CUU" ||
                    RNA.substr(i, 3) == "UUA" ||
                    RNA.substr(i, 3) == "UUG") Polypeptide.push_back('L');
            else if(RNA.substr(i, 3) == "AUG") Polypeptide.push_back('M');
            else if(RNA.substr(i, 3) == "AAC" ||
                    RNA.substr(i, 3) == "AAU") Polypeptide.push_back('N');
            else if(RNA.substr(i, 3) == "CCA" ||
                    RNA.substr(i, 3) == "CCC" ||
                    RNA.substr(i, 3) == "CCG" ||
                    RNA.substr(i, 3) == "CCU") Polypeptide.push_back('P');
            else if(RNA.substr(i, 3) == "CAA" ||
                    RNA.substr(i, 3) == "CAG") Polypeptide.push_back('Q');
            else if(RNA.substr(i, 3) == "AGA" ||
                    RNA.substr(i, 3) == "AGG" ||
                    RNA.substr(i, 3) == "CGA" ||
                    RNA.substr(i, 3) == "CGC" ||
                    RNA.substr(i, 3) == "CGG" ||
                    RNA.substr(i, 3) == "CGU") Polypeptide.push_back('R');
            else if(RNA.substr(i, 3) == "AGC" ||
                    RNA.substr(i, 3) == "AGU" ||
                    RNA.substr(i, 3) == "UCA" ||
                    RNA.substr(i, 3) == "UCC" ||
                    RNA.substr(i, 3) == "UCG" ||
                    RNA.substr(i, 3) == "UCU") Polypeptide.push_back('S');
            else if(RNA.substr(i, 3) == "ACA" ||
                    RNA.substr(i, 3) == "ACC" ||
                    RNA.substr(i, 3) == "ACG" ||
                    RNA.substr(i, 3) == "ACU") Polypeptide.push_back('T');
            else if(RNA.substr(i, 3) == "GUA" ||
                    RNA.substr(i, 3) == "GUC" ||
                    RNA.substr(i, 3) == "GUG" ||
                    RNA.substr(i, 3) == "GUU") Polypeptide.push_back('V');
            else if(RNA.substr(i, 3) == "UGG") Polypeptide.push_back('W');
            else if(RNA.substr(i, 3) == "UAC" ||
                    RNA.substr(i, 3) == "UAU") Polypeptide.push_back('Y');
            else                               Polypeptide.push_back('-');
        }
    }
};

class genca:public genb
{
  public:
    char Monomer;
    genca(string Gene, char A, char B, char C):genb(Gene)
    {
        Monomer = C;
    }
};

class gencb:public genb
{
  public:
    char Monomer1;
    char Monomer2;
    gencb(string Gene, char A, char B, char C):genb(Gene)
    {
        Monomer1 = B;
        Monomer2 = C;
    }
};

class gencz:public genb
{
  public:
    string Replica;
    gencz(string Gene, string Template):genb(Gene)
    {
        for(int i = 0; i < Template.size(); i++)
        {
                 if(Template[i] == 'A') Replica.push_back('T');
            else if(Template[i] == 'C') Replica.push_back('G');
            else if(Template[i] == 'G') Replica.push_back('C');
            else if(Template[i] == 'T') Replica.push_back('A');
            else                        Replica.push_back('-');
        }
    }
};

class cell
{
  public:
    vector<string> DNAs;
    vector<string> tRNAs;
    vector<string> rRNAs;
    vector<string> Polypeptides1;
    vector<string> Polypeptides2;
    vector<string> Polypeptides3;
    vector<char> Monomers1;
    vector<char> Monomers2;
    vector<char> Monomers3;
	
    cell(vector<string> V0,
         vector<string> V1,
         vector<string> V2,
         vector<string> V3,
         vector<string> V4,
         vector<string> V5,
         vector<char> V6,
         vector<char> V7,
         vector<char> V8)
    {
        DNAs = V0;
        tRNAs = V1;
        rRNAs = V2;
        Polypeptides1 = V3;
        Polypeptides2 = V4;
        Polypeptides3 = V5;
        Monomers1 = V6;
        Monomers2 = V7;
        Monomers3 = V8;

        for(int i = 0; i < 10; i++)
        {
            gena G1(DNAs[0].substr(0, 9)); tRNAs.push_back(G1.RNA);
            gena G2(DNAs[0].substr(9, 9)); rRNAs.push_back(G2.RNA);
            genb G3(DNAs[0].substr(18, 9)); Polypeptides1.push_back(G3.Polypeptide);
            genb G4(DNAs[0].substr(27, 9)); Polypeptides2.push_back(G4.Polypeptide);
            genb G5(DNAs[0].substr(36, 9)); Polypeptides3.push_back(G5.Polypeptide);
            genca G6(DNAs[0].substr(45, 9), 'U', 'V', 'X');
                Monomers1.push_back(G6.Monomer);
            gencb G7(DNAs[0].substr(54, 9), 'W', 'Y', 'Z');
                Monomers2.push_back(G7.Monomer1);
                Monomers3.push_back(G7.Monomer2);
        }
        vector<string> DNAreplicas;
        gencz G8a(DNAs[0].substr(63, 9), DNAs[0]);
            DNAreplicas.push_back(G8a.Replica);
        gencz G8b(DNAs[0].substr(63, 9), DNAs[1]);
            DNAreplicas.push_back(G8b.Replica);
        DNAs.insert(DNAs.begin() + 1, DNAreplicas.begin(), DNAreplicas.end());
    }
};

int main()
{
    string Sa, Sb;
    Sa = "CGTACGCTGCTTAAGCCTGTGTATTTTGATTACTTGGGTGTTTCTTCGTGTCATACCATGCGGACACTACTC";
    Sb = "GCATGCGACGAATTCGGACACATAAAACTAATGAACCCACAAAGAAGCACAGTATGGTACGCCTGTGATGAG";
	vector<string> V0;
	V0.push_back(Sa);
    V0.push_back(Sb);
	vector<string> V1(10, "GCAUGCGAC"), V2(10, "GCAUGCGAC");
	vector<string> V3(10, "HIK"), V4(10, "LMN"), V5(10, "PQR");
	vector<char> V6(10, 'X'), V7(10, 'Y'), V8(10, 'Z');
	cout << "Picture 1:" << "\n\n";
	for(int i = 0; i < V0.size(); i++)
        cout << V0[i] << endl;
    cout << "\n";
    for(int i = 0; i < V1.size(); i++)
        cout << V1[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V2.size(); i++)
        cout << V2[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V3.size(); i++)
        cout << V3[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V4.size(); i++)
        cout << V4[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V5.size(); i++)
        cout << V5[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V6.size(); i++)
        cout << V6[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V7.size(); i++)
        cout << V7[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < V8.size(); i++)
        cout << V8[i] << " ";
    cout << "\n\n";

	cell Cell(V0, V1, V2, V3, V4, V5, V6, V7, V8);
	cout << "Picture 2:" << "\n\n";
	for(int i = 0; i < Cell.DNAs.size(); i++)
        cout << Cell.DNAs[i] << endl;
    cout << "\n";
    for(int i = 0; i < Cell.tRNAs.size(); i++)
        cout << Cell.tRNAs[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.rRNAs.size(); i++)
        cout << Cell.rRNAs[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.Polypeptides1.size(); i++)
        cout << Cell.Polypeptides1[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.Polypeptides2.size(); i++)
        cout << Cell.Polypeptides2[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.Polypeptides3.size(); i++)
        cout << Cell.Polypeptides3[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.Monomers1.size(); i++)
        cout << Cell.Monomers1[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.Monomers2.size(); i++)
        cout << Cell.Monomers2[i] << " ";
    cout << "\n\n";
    for(int i = 0; i < Cell.Monomers3.size(); i++)
        cout << Cell.Monomers3[i] << " ";
    cout << "\n\n";
    
    return 0;
}
