//Experiment 2-2
/*Nikita Tirjatkin
  Laboratory for in silico life construction
  Januar 2011*/

#include <string>
#include <iostream>
using namespace std;

class gena
{
  public:
    string RNA;
    gena(string Gene)
    {
        for(int i = 0; i < Gene.size(); i++)
        {
            if(Gene[i] == 'A') RNA.push_back('U');
            else if(Gene[i] == 'C') RNA.push_back('G');
            else if(Gene[i] == 'G') RNA.push_back('C');
            else if(Gene[i] == 'T') RNA.push_back('A');
            else RNA.push_back('-');
        }
    }
};

class genb:public gena
{
  public:
    string Polypeptide;
    genb(string Gene):gena(Gene)
    {
        for(int i = 0; i < RNA.size(); i += 3)
        {
            if(RNA.substr(i, 3) == "GCA" ||
                    RNA.substr(i, 3) == "GCC" ||
                    RNA.substr(i, 3) == "GCG" ||
                    RNA.substr(i, 3) == "GCU") Polypeptide.push_back('A');
            else if(RNA.substr(i, 3) == "UGC" ||
                    RNA.substr(i, 3) == "UGU") Polypeptide.push_back('C');
            else if(RNA.substr(i, 3) == "GAC" ||
                    RNA.substr(i, 3) == "GAU") Polypeptide.push_back('D');
            else if(RNA.substr(i, 3) == "GAA" ||
                    RNA.substr(i, 3) == "GAG") Polypeptide.push_back('E');
            else if(RNA.substr(i, 3) == "UUC" ||
                    RNA.substr(i, 3) == "UUU") Polypeptide.push_back('F');
            else if(RNA.substr(i, 3) == "GGA" ||
                    RNA.substr(i, 3) == "GGC" ||
                    RNA.substr(i, 3) == "GGG" ||
                    RNA.substr(i, 3) == "GGU") Polypeptide.push_back('G');
            else if(RNA.substr(i, 3) == "CAC" ||
                    RNA.substr(i, 3) == "CAU") Polypeptide.push_back('H');
            else if(RNA.substr(i, 3) == "AUA" ||
                    RNA.substr(i, 3) == "AUC" ||
                    RNA.substr(i, 3) == "AUU") Polypeptide.push_back('I');
            else if(RNA.substr(i, 3) == "AAA" ||
                    RNA.substr(i, 3) == "AAG") Polypeptide.push_back('K');
            else if(RNA.substr(i, 3) == "CUA" ||
                    RNA.substr(i, 3) == "CUC" ||
                    RNA.substr(i, 3) == "CUG" ||
                    RNA.substr(i, 3) == "CUU" ||
                    RNA.substr(i, 3) == "UUA" ||
                    RNA.substr(i, 3) == "UUG") Polypeptide.push_back('L');
            else if(RNA.substr(i, 3) == "AUG") Polypeptide.push_back('M');
            else if(RNA.substr(i, 3) == "AAC" ||
                    RNA.substr(i, 3) == "AAU") Polypeptide.push_back('N');
            else if(RNA.substr(i, 3) == "CCA" ||
                    RNA.substr(i, 3) == "CCC" ||
                    RNA.substr(i, 3) == "CCG" ||
                    RNA.substr(i, 3) == "CCU") Polypeptide.push_back('P');
            else if(RNA.substr(i, 3) == "CAA" ||
                    RNA.substr(i, 3) == "CAG") Polypeptide.push_back('Q');
            else if(RNA.substr(i, 3) == "AGA" ||
                    RNA.substr(i, 3) == "AGG" ||
                    RNA.substr(i, 3) == "CGA" ||
                    RNA.substr(i, 3) == "CGC" ||
                    RNA.substr(i, 3) == "CGG" ||
                    RNA.substr(i, 3) == "CGU") Polypeptide.push_back('R');
            else if(RNA.substr(i, 3) == "AGC" ||
                    RNA.substr(i, 3) == "AGU" ||
                    RNA.substr(i, 3) == "UCA" ||
                    RNA.substr(i, 3) == "UCC" ||
                    RNA.substr(i, 3) == "UCG" ||
                    RNA.substr(i, 3) == "UCU") Polypeptide.push_back('S');
            else if(RNA.substr(i, 3) == "ACA" ||
                    RNA.substr(i, 3) == "ACC" ||
                    RNA.substr(i, 3) == "ACG" ||
                    RNA.substr(i, 3) == "ACU") Polypeptide.push_back('T');
            else if(RNA.substr(i, 3) == "GUA" ||
                    RNA.substr(i, 3) == "GUC" ||
                    RNA.substr(i, 3) == "GUG" ||
                    RNA.substr(i, 3) == "GUU") Polypeptide.push_back('V');
            else if(RNA.substr(i, 3) == "UGG") Polypeptide.push_back('W');
            else if(RNA.substr(i, 3) == "UAC" ||
                    RNA.substr(i, 3) == "UAU") Polypeptide.push_back('Y');
            else Polypeptide.push_back('-');
        }
    }
};

int main()
{
	string Sa, Sb;
    Sa="CGTACGCTGCTTAAGCCTGTGTATTTTGATTACTTGGGTGTTTCTTCGTGTCATACCATGCGGACACTACTC";
    Sb="GCATGCGACGAATTCGGACACATAAAACTAATGAACCCACAAAGAAGCACAGTATGGTACGCCTGTGATGAG";
	cout << "Picture 1:\n\n"
		 << Sa << endl
		 << Sb << "\n\n";
	cout << "Picture 2:\n\n"
		 << Sa << "\n\n\n"
		 << Sb << "\n\n";

	genb G3(Sa.substr(18, 9));
	cout << "Picture 3:\n\n"
		 << Sa << endl
		 << "                  " << G3.RNA << "\n\n"
		 << Sb << "\n\n";
	cout << "Picture 4:\n\n"
		 << Sa << endl
		 << Sb << "\n\n"
		 << "                  " << G3.RNA << "\n\n";
	cout << "Picture 5:\n\n"
		 << Sa << endl
		 << Sb << "\n\n"
		 << "                  " << G3.RNA << endl
		 << "                       " << G3.Polypeptide << "\n\n";
	cout << "Picture 6:\n\n"
		 << Sa << endl
		 << Sb << "\n\n"
		 << "                  " << G3.RNA << "\n\n"
		 << "                       " << G3.Polypeptide << "\n\n";
	
	return 0;
}
