//Experiment 4-2
/*Nikita Tirjatkin
  Laboratory for in silico life construction
  Januar 2011*/

#include <string>
#include <vector>
#include <list>
#include <deque>
#include <iostream>
using namespace std;

class gena
{
  public:
    string RNA;
    gena(string Gene)
    {
        for(int i = 0; i < Gene.size(); i++)
        {
                 if(Gene[i] == 'A') RNA.push_back('U');
            else if(Gene[i] == 'C') RNA.push_back('G');
            else if(Gene[i] == 'G') RNA.push_back('C');
            else if(Gene[i] == 'T') RNA.push_back('A');
            else                    RNA.push_back('-');
        }
    }
};

class genb:public gena
{
  public:
    string Polypeptide;
    genb(string Gene):gena(Gene)
    {
        for(int i = 0; i < RNA.size(); i += 3)
        {
                 if(RNA.substr(i, 3) == "GCA" ||
                    RNA.substr(i, 3) == "GCC" ||
                    RNA.substr(i, 3) == "GCG" ||
                    RNA.substr(i, 3) == "GCU") Polypeptide.push_back('A');
            else if(RNA.substr(i, 3) == "UGC" ||
                    RNA.substr(i, 3) == "UGU") Polypeptide.push_back('C');
            else if(RNA.substr(i, 3) == "GAC" ||
                    RNA.substr(i, 3) == "GAU") Polypeptide.push_back('D');
            else if(RNA.substr(i, 3) == "GAA" ||
                    RNA.substr(i, 3) == "GAG") Polypeptide.push_back('E');
            else if(RNA.substr(i, 3) == "UUC" ||
                    RNA.substr(i, 3) == "UUU") Polypeptide.push_back('F');
            else if(RNA.substr(i, 3) == "GGA" ||
                    RNA.substr(i, 3) == "GGC" ||
                    RNA.substr(i, 3) == "GGG" ||
                    RNA.substr(i, 3) == "GGU") Polypeptide.push_back('G');
            else if(RNA.substr(i, 3) == "CAC" ||
                    RNA.substr(i, 3) == "CAU") Polypeptide.push_back('H');
            else if(RNA.substr(i, 3) == "AUA" ||
                    RNA.substr(i, 3) == "AUC" ||
                    RNA.substr(i, 3) == "AUU") Polypeptide.push_back('I');
            else if(RNA.substr(i, 3) == "AAA" ||
                    RNA.substr(i, 3) == "AAG") Polypeptide.push_back('K');
            else if(RNA.substr(i, 3) == "CUA" ||
                    RNA.substr(i, 3) == "CUC" ||
                    RNA.substr(i, 3) == "CUG" ||
                    RNA.substr(i, 3) == "CUU" ||
                    RNA.substr(i, 3) == "UUA" ||
                    RNA.substr(i, 3) == "UUG") Polypeptide.push_back('L');
            else if(RNA.substr(i, 3) == "AUG") Polypeptide.push_back('M');
            else if(RNA.substr(i, 3) == "AAC" ||
                    RNA.substr(i, 3) == "AAU") Polypeptide.push_back('N');
            else if(RNA.substr(i, 3) == "CCA" ||
                    RNA.substr(i, 3) == "CCC" ||
                    RNA.substr(i, 3) == "CCG" ||
                    RNA.substr(i, 3) == "CCU") Polypeptide.push_back('P');
            else if(RNA.substr(i, 3) == "CAA" ||
                    RNA.substr(i, 3) == "CAG") Polypeptide.push_back('Q');
            else if(RNA.substr(i, 3) == "AGA" ||
                    RNA.substr(i, 3) == "AGG" ||
                    RNA.substr(i, 3) == "CGA" ||
                    RNA.substr(i, 3) == "CGC" ||
                    RNA.substr(i, 3) == "CGG" ||
                    RNA.substr(i, 3) == "CGU") Polypeptide.push_back('R');
            else if(RNA.substr(i, 3) == "AGC" ||
                    RNA.substr(i, 3) == "AGU" ||
                    RNA.substr(i, 3) == "UCA" ||
                    RNA.substr(i, 3) == "UCC" ||
                    RNA.substr(i, 3) == "UCG" ||
                    RNA.substr(i, 3) == "UCU") Polypeptide.push_back('S');
            else if(RNA.substr(i, 3) == "ACA" ||
                    RNA.substr(i, 3) == "ACC" ||
                    RNA.substr(i, 3) == "ACG" ||
                    RNA.substr(i, 3) == "ACU") Polypeptide.push_back('T');
            else if(RNA.substr(i, 3) == "GUA" ||
                    RNA.substr(i, 3) == "GUC" ||
                    RNA.substr(i, 3) == "GUG" ||
                    RNA.substr(i, 3) == "GUU") Polypeptide.push_back('V');
            else if(RNA.substr(i, 3) == "UGG") Polypeptide.push_back('W');
            else if(RNA.substr(i, 3) == "UAC" ||
                    RNA.substr(i, 3) == "UAU") Polypeptide.push_back('Y');
            else                               Polypeptide.push_back('-');
        }
    }
};

class genca:public genb
{
  public:
    char Monomer;
    genca(string Gene, char A, char B, char C):genb(Gene)
    {
        Monomer = C;
    }
};

class gencb:public genb
{
  public:
    char Monomer1;
    char Monomer2;
    gencb(string Gene, char A, char B, char C):genb(Gene)
    {
        Monomer1 = B;
        Monomer2 = C;
    }
};

class gencz:public genb
{
  public:
    string Replica;
    gencz(string Gene, string Template):genb(Gene)
    {
        for(int i = 0; i < Template.size(); i++)
        {
                 if(Template[i] == 'A') Replica.push_back('T');
            else if(Template[i] == 'C') Replica.push_back('G');
            else if(Template[i] == 'G') Replica.push_back('C');
            else if(Template[i] == 'T') Replica.push_back('A');
            else                        Replica.push_back('-');
        }
    }
};

class component
{
public:
	virtual ~component(){}
	virtual void displayImage()const = 0;
};

class monomer:public component
{
public:
	char Monomer;
	monomer();
	monomer(char M):Monomer(M){};
	virtual ~monomer(){}
	void displayImage()const{cout << Monomer << " ";}
};

class polymer:public component
{
public:	
	string Polymer;
	polymer();
	polymer(string P):Polymer(P){};
	virtual ~polymer(){}
	void displayImage()const{cout << Polymer << " ";}
};

class composite:public component
{
public:	
	list<component *> pComponents;
	virtual ~composite()
	{
		list<component *>::iterator i;
		for(i = pComponents.begin(); i != pComponents.end(); ++i)
		{
			delete *i;
			*i = 0;
		}
	}
	void displayImage()const
	{
		list<component *>::const_iterator i;
		for(i = pComponents.begin(); i != pComponents.end(); ++i)
			(*i)->displayImage();
		cout << "\n\n";
	}
	void addComponent(component * pC){pComponents.push_back(pC);}
	void eraseComponent(list<component *>::iterator P){pComponents.erase(P);}
};

class compositor
{
public:
	composite * composeComposite1(string S)
	{
		gena G1(S.substr(0, 9)); polymer * tRNA = new polymer(G1.RNA);
		gena G2(S.substr(9, 9)); polymer * rRNA = new polymer(G2.RNA);
		genb G3(S.substr(18, 9)); polymer * Polypeptide1 =
			                                      new polymer(G3.Polypeptide);
		genb G4(S.substr(27, 9)); polymer * Polypeptide2 =
			                                      new polymer(G4.Polypeptide);
		genb G5(S.substr(36, 9)); polymer * Polypeptide3 =
			                                      new polymer(G5.Polypeptide);
		genca G6(S.substr(45, 9), 'U', 'V', 'X'); monomer * Monomer1 =
			                                      new monomer(G6.Monomer);
		gencb G7(S.substr(54, 9), 'W', 'Y', 'Z'); monomer * Monomer2 =
			                                      new monomer(G7.Monomer1);
		                                          monomer * Monomer3 =
												  new monomer(G7.Monomer2);	
		composite * tRNAs = new composite;
		composite * rRNAs = new composite;
		composite * Polypeptides1 = new composite;
		composite * Polypeptides2 = new composite;
		composite * Polypeptides3 = new composite;
		composite * Monomers1 = new composite;
		composite * Monomers2 = new composite;
		composite * Monomers3 = new composite;
		for(unsigned int i = 0; i < 10; ++i)
		{
			tRNAs->addComponent(tRNA);
			rRNAs->addComponent(rRNA);
			Polypeptides1->addComponent(Polypeptide1);
			Polypeptides2->addComponent(Polypeptide2);
			Polypeptides3->addComponent(Polypeptide3);
			Monomers1->addComponent(Monomer1);
			Monomers2->addComponent(Monomer2);
			Monomers3->addComponent(Monomer3);
		}
		composite * Ca = new composite;
		Ca->addComponent(tRNAs);
		Ca->addComponent(rRNAs);
		Ca->addComponent(Polypeptides1);
		Ca->addComponent(Polypeptides2);
		Ca->addComponent(Polypeptides3);
		Ca->addComponent(Monomers1);
		Ca->addComponent(Monomers2);
		Ca->addComponent(Monomers3);
		composite * C = new composite;
		C->addComponent(Ca);
		return C;
	}
	composite * composeComposite2(string S)
	{
		genb G1(S.substr(3, 27)); polymer * Polypeptide4 =
			                                      new polymer(G1.Polypeptide);
		genb G2(S.substr(6, 27)); polymer * Polypeptide5 =
			                                      new polymer(G2.Polypeptide);
		genb G3(S.substr(9, 27)); polymer * Polypeptide6 =
			                                      new polymer(G3.Polypeptide);
		composite * Polypeptides4 = new composite;
		composite * Polypeptides5 = new composite;
		composite * Polypeptides6 = new composite;
		for(unsigned int i = 0; i < 20; ++i)
		{
			Polypeptides4->addComponent(Polypeptide4);
			Polypeptides5->addComponent(Polypeptide5);
			Polypeptides6->addComponent(Polypeptide6);
		}
		composite * Cb = new composite;
		Cb->addComponent(Polypeptides4);
		Cb->addComponent(Polypeptides5);
		Cb->addComponent(Polypeptides6);
		return Cb;
	}
};

class cell
{
public:
	vector<string> DNA;
	composite * pMatrix;
	composite * plMatrix, * prMatrix;
	static int Number;
	cell(vector<string> V, composite * pM):DNA(V), pMatrix(pM)
	{
		Number++;
		cout << "Cell " << Number << "\n\n" << "Picture 1:\n\n";
		for(int i = 0; i < DNA.size(); ++i)
			cout << DNA[i] << endl;
		cout << endl;
		pMatrix->displayImage();

		composite * pMatrix2;
		compositor Compositor2;
		pMatrix2 = Compositor2.composeComposite2(DNA[0]);
		pMatrix->addComponent(pMatrix2);
		list<component *>::iterator Position = pMatrix->pComponents.begin();
		pMatrix->eraseComponent(Position);
		cout << "Picture 2:\n\n";
		for(int i = 0; i < DNA.size(); ++i)
			cout << DNA[i] << endl;
		cout << endl;		
		pMatrix->displayImage();
		
		compositor Compositor3;
		plMatrix = Compositor3.composeComposite1(DNA[0]);
		prMatrix = Compositor3.composeComposite1(DNA[0]);
		Position = pMatrix->pComponents.begin();
		pMatrix->eraseComponent(Position);

		vector<string> DNAreplicas;
        gencz G8a(DNA[0].substr(63, 9), DNA[0]);
        DNAreplicas.push_back(G8a.Replica);
        gencz G8b(DNA[0].substr(63, 9), DNA[1]);
        DNAreplicas.push_back(G8b.Replica);
        DNA.insert(DNA.begin() + 1, DNAreplicas.begin(), DNAreplicas.end());

		cout << "Picture 3:\n\n";
		for(int i = 0; i < DNA.size(); ++i)
			cout << DNA[i] << endl;
		cout << endl;
		pMatrix->displayImage();
		plMatrix->displayImage();
		prMatrix->displayImage();
	}
};

int cell::Number = 0;

class cp
{
  public:
    deque<cell> Cells;
    cp(cell Cell)
    {
        Cells.push_back(Cell);
		
        while(Cell.Number < 7)//Cells.max_size())
        {
            Cell = Cells.front();
			Cells.pop_front();
			
            vector<string> lDNA(Cell.DNA.begin(), Cell.DNA.begin() + Cell.DNA.size()/2);
            vector<string> rDNA(Cell.DNA.begin() + Cell.DNA.size()/2, Cell.DNA.end());
            cell lCell(lDNA, Cell.plMatrix);
			cell rCell(rDNA, Cell.prMatrix);
            Cells.push_back(lCell);
            Cells.push_back(rCell);
        }
    }
};

int main()
{
	
	vector<string> Strands;
	string S("CGTACGCTGCTTAAGCCTGTGTATTTTGATTACTTGGGTGTTTCTTCGTGTCATACCATGCGGACACTACTC");
    Strands.push_back(S);
	gencz Ga0(Strands[0].substr(63, 9), S);
	Strands.push_back(Ga0.Replica);

	composite * pMatrix1;
	compositor Compositor1;
	pMatrix1 = Compositor1.composeComposite1(S);
	cell PrimordialCell(Strands, pMatrix1);
	cp CellProgression(PrimordialCell);
	
	return 0;
}
